* Select a stratified simple random sample without replacement
* use "nhis.dta", clear

* Select an stsrswor of 5 persons from each stratum
use "C:\Projects\Stata Weighting Book\Data\nhis\nhis.dta", clear
set seed 339487731
sample 5, count by(educ_r)

* Select an stsrswor of different size samples from different strata
use "C:\Projects\Stata Weighting Book\Data\nhis\nhis.dta", clear
	* Sort population
sort educ_r
tabulate educ_r, matcell(Nh)  

matrix nh = (3, 4, 5, 6)
mat list Nh
mat list nh

	* method using foreach loop
foreach i of local edlev{
	local n = nh[1,`i']
	sample `n' if educ_r == `i', count
}
	* method using forvalues loop
forvalues i=1/4 {
	local n = nh[1,`i']
	sample `n' if educ_r == `i', count
}
	* sort sample
sort educ_r

gen stsrswt = Nh[1,1]/nh[1,1] if educ_r == 1
replace stsrswt = Nh[2,1]/nh[1,2] if educ_r == 2
replace stsrswt = Nh[3,1]/nh[1,3] if educ_r == 3
replace stsrswt = Nh[4,1]/nh[1,4] if educ_r == 4
list, clean
