*--------------------------------------------------------------------------------------------------
* File: 	C:\Projects\Stata Weighting Book\program files\3 Nonresponse\Ex.3.4_rpart.do
* Project:  Stata weighting book
* Date: 	11/27/2015
* Revised:  
* Author:	R. Valliant
* Purpose:	Illustrate use of R rpart and rpart.plot packages. Call R from Stata.
*--------------------------------------------------------------------------------------------------

log using "C:\Projects\Stata Weighting Book\Program files\3 Nonresponse\Ex.3.4_rpart.smcl", replace

* Install Stata package rsource from http://fmwww.bc.edu/RePEc/bocode/r 
* set globals so that Stata finds installed version of R
global Rterm_path `"C:\Program Files\R\R-3.3.2\bin\x64\Rterm.exe"'
global Rterm_options `"--vanilla"'

rsource, terminator(END_OF_R)
   require(PracTools)
   require(rpart)
   require(rpart.plot)
   require(foreign)
   data(nhis)
   set.seed(15097)
  
   t1 <- rpart(resp ~ age + hisp + race + parents_r + educ_r,
            method = "class", control = rpart.control(minbucket = 50, cp=0), data = nhis)
			
   classes <- data.frame(t1$where)
   write.dta(classes, file = "C:\\Projects\\Stata Weighting Book\\Data\\nhis\\rpartclasses.dta")
   print(t1, digits=4)
#   cols <- ifelse(t1$frame$yval == 1, "darkred", "green4")
   cols <- ifelse(t1$frame$yval == 1, "gray50", "black")

#   pdf(file = "C:\\Projects\\Stata Weighting Book\\Tex files\\Figures\\Fig31rparttree.pdf")
   pdf(file = "C:\\Projects\\Stata Weighting Book\\Tex files\\Figures\\Fig31rparttree (grayscale).pdf")
   png(file = "C:\\Projects\\Stata Weighting Book\\Tex files\\Figures\\Fig31rparttree (grayscale).png")
    prp(t1, main="",
       extra=106,           # display prob of survival and percent of obs
       nn=TRUE,             # display the node numbers
       fallen.leaves=TRUE,  # put the leaves on the bottom of the page
       branch=.5,           # change angle of branch lines
       faclen=0,            # do not abbreviate factor levels
       trace=1,             # print the automatically calculated cex
       shadow.col="gray",   # shadows under the leaves
       branch.lty=1,        # draw branches using solid lines
       branch.type=5,       # branch lines width = weight (frame$wt), no. of cases here
       split.cex=1.2,       # make the split text larger than the node text
       split.prefix="is ",  # put "is " before split text
       split.suffix="?",    # put "?" after split text
       col=cols, border.col=cols,   # green if survived
       split.box.col="lightgray",   # lightgray split boxes (default is white)
       split.border.col="darkgray", # darkgray border on split boxes
       split.round=.5)              # round the split box corners a tad
   dev.off()   
   q()
END_OF_R

log close
