*****************************************************************************************
* FILE:     C:\Projects\Stata Weighting Book\Data\program files\Ex.4.2_recover.poptots.do
* PROJECT:  Stata weighting book
* DATE:     12/12/2016
* AUTHOR:   R. Valliant
* PURPOSE:  Recover control totals from a public use file
*****************************************************************************************

log using "C:\Projects\Stata Weighting Book\Program files\4 Calibration\Ex.4.2_recover.poptots.smcl", replace

use "C:\\Projects\\Stata Weighting Book\\Data\\nhis\\nhis_sam.dta", clear
label define age_lab 1 "<18" 2 "18-24" 3 "25-44" 4 "45-64" 5 "65+"
label values age_grp age_lab
gen notcov1 = abs(notcov - 2)

	* estimate total persons without medical insurance using PS weight but do not 
	* specify that these are PS wts
svyset [pweight = pswt]
svy: total notcov1

	* recover pop controls 
svy: tab age_grp, count format(%12.0f)

	* compute and save PS wts; ps_wt is the same as wt on the file (as it should be)
svycal regress i.age_grp [pw=wt], gen(ps_wt) totals(_cons=21588 1.age_grp=5991 2.age_grp=2014 3.age_grp=6124 4.age_grp=5011 5.age_grp=2448)
summarize ps_wt

	* add a variable to each record that holds the pop count for its PS
gen pstot = 5991
replace pstot = 2014 if age_grp == 2
replace pstot = 6124 if age_grp == 3
replace pstot =  5011 if age_grp == 4
replace pstot =  2448 if age_grp == 5

svyset [pweight=wt], poststrata(age_grp) postweight(pstot)
svy: tab age_grp, count se


	* notcov1 totals overall and by age_grp
svy: total notcov1
svy: total notcov1, over(age_grp) 
svy: mean notcov1, over(age_grp)

log close
