*****************************************************************************************
* FILE:     C:\Projects\Stata Weighting Book\Data\Program files\Ex.4.3_rake.do
* PROJECT:  Stata weighting book
* DATE:     04/22/2016
* AUTHOR:   R. Valliant
* PURPOSE:  Illustrate raking wt calculation
*****************************************************************************************

log using "C:\Projects\Stata Weighting Book\Program files\4 Calibration\Ex.4.3_rake.smcl", replace

use "C:\\Projects\\Stata Weighting Book\\Data\\nhis\\nhis_sam.dta", clear
label define age_lab 1 "<18" 2 "18-24" 3 "25-44" 4 "45-64" 5 "65+"
label values age_grp age_lab
recode hisp (1=1) (2=2) (3=3) (4=3), gen(hispr)

svycal rake i.age_grp i.hispr [pw=wt], gen(rake_wt) totals(_cons=21588 1.age_grp=5991 2.age_grp=2014 3.age_grp=6124 4.age_grp=5011 5.age_grp=2448 1.hispr=5031 2.hispr=12637 3.hispr=3920)
summarize(rake_wt)


gen medicaid1 = abs(medicaid - 2)

svyset [pweight=wt], rake(i.age_grp i.hispr, totals(_cons=21588 1.age_grp=5991 2.age_grp=2014 3.age_grp=6124 4.age_grp=5011 5.age_grp=2448 1.hispr=5031 2.hispr=12637 3.hispr=3920))
svy: mean medicaid1

*--------------------------------------------------------------------------------------------------
    * test ll() ul() option for bounds
svycal rake i.age_grp i.hispr [pw=wt], gen(rake_wtB) totals(_cons=21588 1.age_grp=5991 2.age_grp=2014 3.age_grp=6124 4.age_grp=5011 5.age_grp=2448 1.hispr=5031 2.hispr=12637 3.hispr=3920) ll(0.8) ul(1.2)
summarize(rake_wtB)

*--------------------------------------------------------------------------------------------------
twoway scatter wt rake_wt || line wt wt, legend(off)
twoway scatter rake_wtB rake_wt || line rake_wt rake_wt, legend(off)


svyset [pweight=wt], rake(i.age_grp i.hispr, totals(_cons=21588 1.age_grp=5991 2.age_grp=2014 3.age_grp=6124 4.age_grp=5011 5.age_grp=2448 1.hispr=5031 2.hispr=12637 3.hispr=3920))
svy: tab age_grp, count se
svy: tab hispr, count se

log close
