*****************************************************************************************
* FILE:     C:\Projects\Stata Weighting Book\Data\program files\Ex.4.8_4.9_smho.greg.bdd.do
* PROJECT:  Stata weighting book
* DATE:     05/09/2015
* AUTHOR:   R. Valliant
* PURPOSE:  Illustrate GREG wt calculation with wt change bounding
*****************************************************************************************

log using "C:\Projects\Stata Weighting Book\Program files\4 Calibration\Ex.4.8_4.9_smho.greg.bdd.smcl", replace

    * 2 continuous variablles & factor crossed with continuous variable
    * no wt bounding
use "C:\Projects\Stata Weighting Book\Data\smho\smhosam.pps.dta", clear
    * create gregwts with svycal
svycal regress SEENCNT EOYCNT i.hosptype#c.BEDS [pw = d], gen(gregwt) totals(1349241 505345 37978 13066 9573 10077, copy) nocons

svyset ID [pweight = gregwt], strata(hosptype) regress(SEENCNT EOYCNT i.hosptype#c.BEDS, totals(1349241 505345 37978 13066 9573 10077, copy) nocons)

summarize d

summarize gregwt

summarize gregwt, detail
 
    * Stata does not allow negative weights            
svy: total BEDS, over(hosptype) 
svy: total SEENCNT EOYCNT EXPTOTAL

***************************************************************************************************
    * Same example as above: 2 continuous variablles & factor crossed with continuous variable
    * with wt bounding
use "C:\Projects\Stata Weighting Book\Data\smho\smhosam.pps.dta", clear
    * create gregwts with svycal
svycal regress SEENCNT EOYCNT i.hosptype#c.BEDS [pw = d], gen(gregwtB) totals(1349241 505345 37978 13066 9573 10077, copy) nocons ll(0.4) ul(3.0)
svyset ID [pweight = gregwtB], strata(hosptype) regress(SEENCNT EOYCNT i.hosptype#c.BEDS, totals(1349241 505345 37978 13066 9573 10077, copy) nocons)

summarize gregwtB, detail

svy: total BEDS, over(hosptype) 
    * Controls hit and SEs = zero
 
gen exptot = EXPTOTAL/10^6
svy: total SEENCNT EOYCNT exptot

twoway scatter gregwtB gregwt d || line gregwt gregwt, mfcolor(gs16) xtitle("Unbounded GREG weights") ytitle("Bounded GREG weights")
twoway scatter gregwt d, mlcolor(gs0) mfcolor(gs16) || scatter gregwtB d, mlcolor(gs0) mfcolor(gs10) || line gregwt gregwt, mfcolor(gs16) xtitle("Initial pps weights") ytitle("Bounded GREG weights")

#delimit ;
twoway scatter gregwt d, mlcolor(gs0) mfcolor(gs16) || scatter gregwtB d, mlcolor(gs0) mfcolor(gs10) || line gregwt gregwt, mfcolor(gs16) 
    xtitle("Initial pps weights") ytitle("Bounded GREG weights") 
    legend(label(1 "gregwt") label(2 "gregwtB") label (3 "45 degrees")) ;
#delimit cr

*graph export "C:\Projects\Stata Weighting Book\Tex files\Figures\Fig41gregwts.pdf", replace

log close
