*****************************************************************************************
* FILE:     C:\Projects\Stata Weighting Book\Data\program files\bootstrap(rsource).smho.do
* PROJECT:  Stata weighting book
* DATE:     05/01/2015
* AUTHOR:   R. Valliant
* PURPOSE:  Illustrate calculation of Rao-Wu bootstrap weights
*****************************************************************************************

log using "C:\Projects\Stata Weighting Book\Program files\5 Wts for Var Est\Ex.5.10_bootstrap(rsource).smho.smcl", replace

global Rterm_path `"C:\Program Files\R\R-3.3.2\bin\x64\Rterm.exe"'
global Rterm_options `"--vanilla"'

rsource, terminator(END_OF_R)
require(foreign)
require(survey)
smhosam <- read.dta("C:\\Projects\\Stata Weighting Book\\Data\\smho\\smhosam.dta")
smho.dsgn <- svydesign(ids = ~0,
                       strata = ~hosptype,
                       data = smhosam,
                       weights = ~wt)
B <- 500
smho.boot <- as.svrepdesign(design = smho.dsgn,
                             type = "subbootstrap",
                             replicates = B)
bootwts <- smho.boot$repweights$weights
dwts <- matrix(rep(smhosam$wt, B), ncol=B, byrow=FALSE)
dat <- data.frame(smho.boot$variables, bwt = bootwts * dwts)
write.dta(dat, file = "C:\\Projects\\Stata Weighting Book\\Data\\smho\\smhosam.boot.dta")
END_OF_R

set more off
use "C:\\Projects\\Stata Weighting Book\\Data\\smho\\smhosam.boot.dta", clear
svyset [pweight=wt], bsrweight(bwt_1 - bwt_500) vce(bootstrap) mse
svy: mean SEENCNT BEDS

log close
