*****************************************************************************************
* FILE:     C:\Projects\Stata Weighting Book\Data\Program files\Ex.5.4_rake.survwgt.do
* PROJECT:  Stata weighting book
* DATE:     01/07/2017
* AUTHOR:   R. Valliant
* PURPOSE:  Illustrate raking wt calculation with survwgt
*****************************************************************************************

log using "C:\Projects\Stata Weighting Book\Program files\5 Wts for Var Est\Ex.5.4_rake.survwgt.smcl", replace

use "C:\\Projects\\Stata Weighting Book\\Data\\nhis\\nhis_sam.dta", clear
label define age_lab 1 "<18" 2 "18-24" 3 "25-44" 4 "45-64" 5 "65+"
label values age_grp age_lab
recode hisp (1=1) (2=2) (3=3) (4=3), gen(hispr)

	* create JK1 replicate weights
survwgt create jk1, psu(JKgrp) weight(wt) stem(JK1_)
	* check some counts
svyset [pweight=wt]
svy: tab age_grp, count

svy: tab hispr, count format(%12.0f)
	
gen age_tot     = 5991 if age_grp == 1
replace age_tot = 2014 if age_grp == 2
replace age_tot = 6124 if age_grp == 3
replace age_tot = 5011 if age_grp == 4
replace age_tot = 2448 if age_grp == 5

gen hispr_tot     =  5031 if hispr == 1
replace hispr_tot = 12637 if hispr == 2
replace hispr_tot =  3920 if hispr == 3

tab age_tot
tab hispr_tot

survwgt rake [all], by(age_grp hispr) totvars(age_tot hispr_tot) stem(JKrake)

	* survwgt issues its own updated svyset behind the scenes
	* so, a separate svrset does not have to be issued

svrtab age_grp hispr, count se format(%12.0f)

	* check sums of raked wts
	* sums of raked wts are equal to control totals
summarize JKrake1
svyset [pweight = JKrake1]
svy: tab age_grp, count
svy: tab hispr, count format(%12.0f)

svyset [pweight = JKrake25]
svy: tab age_grp, count
svy: tab hispr, count format(%12.0f)

svyset [pweight = JKrake50]
svy: tab age_grp, count
svy: tab hispr, count format(%12.0f)

log close
