*--------------------------------------------------------------------------------------------------
* File: 	C:\Projects\Stata Weighting Book\Program files\5 Wts for Var Est\Ex.5.6_BRR_nhanes.do
* Project:  Stata Weighting Book
* Date: 	04/08/2017
* Author:	R. Valliant
* Purpose:	Illustrate BRR variances using NHANES data
* 			Create BRR wts with survwgt
*--------------------------------------------------------------------------------------------------

log using "C:\Projects\Stata Weighting Book\Program files\5 Wts for Var Est\Ex.5.6_BRR_nhanes.smcl", replace

use "C:\Projects\Stata Weighting Book\Data\NHANES\2009-2010\nhanes2009.10.dta", clear

label variable ARDDINEX "Differece, inspiration exhalation (cm)"

matrix h2 = (-1, 1 \ 1, 1)

matrix h4 = h2 # h2
matrix h16 = h4 # h4

matrix h32 = h2
forvalues i = 1/4 {
    matrix h32 = h2 # h32
}

matrix h64 = h2 # h32
matrix h128 = h2 # h64

* Check orthogonality
matrix B = h16'*h16
matrix list B

	* This NHANES has 3 PSUs in one stratum
	* recode PSU 3 to 2 in order to illustrate BRR
tabulate SDMVSTRA SDMVPSU

generate newVPSU = SDMVPSU
recode newVPSU (3=2)
tabulate SDMVSTRA newVPSU

svygen brr stdBRRwts [pw=WTMEC2YR], strata(SDMVSTRA) psu(newVPSU) hadamard(h16)
svygen brr fayBRRwts [pw=WTMEC2YR], strata(SDMVSTRA) psu(newVPSU) hadamard(h16) fay(0.5)

*--------------------------------------------------------------------------------------------------

	* Mean difference in inspiration/exhalation chest circumference
svyset newVPSU [pw=WTMEC2YR], brrweight(stdBRR*) vce(brr) mse 
svy: mean ARDDINEX

	* Mean difference in inspiration/exhalation chest circumference
svyset newVPSU [pw=WTMEC2YR], brrweight(fayBRR*) vce(brr) fay(0.5) mse 
svy: mean ARDDINEX

log close
