*****************************************************************************************
* FILE:     C:\Projects\Stata Weighting Book\Program files\6 Nonprobability samples\Ex.6.4_brf.internet.do
* PROJECT:  Stata weighting book
* DATE:     01/31/2017
* AUTHOR:   R. Valliant
* PURPOSE:  Use pseudo inclusion probabilities and estimate SEs
*****************************************************************************************

log using "C:\Projects\Stata Weighting Book\Program files\6 Nonprobability samples\Ex.6.4_brf.internet.smcl", replace

use "C:\Projects\Stata Weighting Book\Data\mibrfss\brf.internet1.wtd.dta", clear

label define smokelabel 1 "smoked 100" 2 "not smoked 100", replace
label define asthlabel 1 "has asthma" 2 "no asthma", replace
label values SMOKE100 smokelabel
label values ASTHMA asthlabel

label define physlabel 1 "Yes" 2 "No", replace
label values PHYSACT physlabel

svyset [pweight=pseudowt]	
svy: tab SMOKE100 PHYSACT, row se stubwidth(15) 

log close
