#********************************************************************************************************
# FILE:     C:\Projects\Stata Weighting Book\program files\7 Special Cases\Ex.7.1_wts.in.reg.do
# TOPIC:    Compare weighted and unweighted regressions
# DATE:     03/11/2017
# AUTHOR:   R. Valliant
#********************************************************************************************************

log using "C:\Projects\Stata Weighting Book\Program files\7 Special Cases\Ex.7.1_wts.in.reg.smcl", replace

use "C:\Projects\Stata Weighting Book\Data\nhis\nhis.large.dta", clear

svyset psu [pw=svywt], strata(stratum) 

tabulate delay_med, missing
gen delay = abs(delay_med - 2)

svy: logit delay i.age_grp i.hisp i.parents i.educ i.race 
predict pred_wt, pr

gen one = 1
svyset psu [pw=one], strata(stratum) 

svy: logit delay i.age_grp i.hisp i.parents i.educ i.race 

predict pred_unwt, pr

twoway scatter pred_unwt pred_wt || line pred_unwt pred_unwt, legend(off) ytitle("Weighted predictions") xtitle("Unweighted predictions")
    
pwcorr pred_wt pred_unwt     
graph export "C:\Projects\Stata Weighting Book\Tex files\Figures\Fig71wtunwtd.pdf", replace

log close
